#!/bin/sh

# run unittest suite using python3

# The software in this package is distributed under the GNU General
# Public License version 2 (with a special exception described below).
#
# A copy of GNU General Public License (GPL) is included in this distribution,
# in the file COPYING.GPL.
#
# As a special exception, if other files instantiate templates or use macros
# or inline functions from this file, or you compile this file and link it
# with other works to produce a work based on this file, this file
# does not by itself cause the resulting work to be covered
# by the GNU General Public License.
#
# However the source code for this file must still be made available
# in accordance with section (3) of the GNU General Public License.
#
# This exception does not invalidate any other reasons why a work based
# on this file might be covered by the GNU General Public License.
#
# Copyright (c) 2016-2018 Intra2net AG <info@intra2net.com>

case "${1:-}" in
    "")     cmd="python3 -m unittest discover test" ;;
    test.*) cmd="python3 -m unittest \"$1\"" ;;
    *)      cmd="python3 -m unittest \"test.$1\"" ;;
esac

# run unittests in regular environment
$cmd
if [[ $? != 0 ]]; then
    exit 1;
fi

# re-run with minimal local to capture errors caused by stdout being bytes
LANG=C $cmd
