# The software in this package is distributed under the GNU General
# Public License version 2 (with a special exception described below).
#
# A copy of GNU General Public License (GPL) is included in this distribution,
# in the file COPYING.GPL.
#
# As a special exception, if other files instantiate templates or use macros
# or inline functions from this file, or you compile this file and link it
# with other works to produce a work based on this file, this file
# does not by itself cause the resulting work to be covered
# by the GNU General Public License.
#
# However the source code for this file must still be made available
# in accordance with section (3) of the GNU General Public License.
#
# This exception does not invalidate any other reasons why a work based
# on this file might be covered by the GNU General Public License.
#
# Copyright (c) 2016-2018 Intra2net AG <info@intra2net.com>

"""
Helpers for type checking and conversion, like `isstr(x)`, `is_file_obj(x)`

Some of these things used to be more complicated when python2 was still
around, so some functions are not that useful anymore.
"""

from io import IOBase


def isstr(var):
    """Alias for `isinstance(var, str)`."""
    return isinstance(var, str)


def is_str_or_byte(var):
    """Returns `True` for `str` and `bytes` objects."""
    return isinstance(var, (str, bytes))


def is_unicode(var):
    """Alias for `isinstance(var, str)`."""
    return isinstance(var, str)


def is_file_obj(var):
    """
    Determine whether given input is the result of 'open(file_name)'.

    Just checks whether given var is subclass of io.IOBase, which is also True
    for 'file-like objects' like StringIO.
    """
    return isinstance(var, IOBase)
